' This is the scripting world's equivalent to NUnit:
'  cscript ScrapeClass_TESTS.vbs > testfile.txt
'  fc testfile.txt lasttest.txt

Dim oScrape
Set oScrape = new ScrapeClass
WScript.Echo "MakeTimestamp () = """ & oScrape.MakeTimestamp () & """"
WScript.Echo "GetLocalhostName() = """ & oScrape.GetLocalhostName() & """"

sSource = "BlockA,Start,1,2,3,End,BlockB,Start,4,5,6,End,BlockC,Start,7,8,9,End"
WScript.Echo "RegExFramedFind search """ & sSource & """"

aExtract = oScrape.RegExFramedFind (sSource, "Block[A-Z]", True, 0, "End", False, 1)
If Not IsArray (aExtract) Then
	WScript.Echo "RegExFramedFind (1) :: no match"
Else
	WScript.Echo "RegExFramedFind (1) :: " & UBound (aExtract, 2) + 1 & " blocks"
	For nI = 0 To UBound (aExtract, 2)
		WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI) & " = """ & Mid (sSource, aExtract (0, nI), aExtract (1, nI)) & """"
		'WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI)
	Next
End If

aExtract = oScrape.RegExFramedFind (sSource, "Block[A-Z]", True, 1, "End", False, 2)
If Not IsArray (aExtract) Then
	WScript.Echo "RegExFramedFind (2) :: no match"
Else
	WScript.Echo "RegExFramedFind (2) :: " & UBound (aExtract, 2) + 1 & " blocks"
	For nI = 0 To UBound (aExtract, 2)
		WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI) & " = """ & Mid (sSource, aExtract (0, nI), aExtract (1, nI)) & """"
		'WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI)
	Next
End If

aExtract = oScrape.RegExFramedFind (sSource, "Block[A-Z]", True, 0, "End", False, 0)
If Not IsArray (aExtract) Then
	WScript.Echo "RegExFramedFind (3) :: no match"
Else
	WScript.Echo "RegExFramedFind (3) :: " & UBound (aExtract, 2) + 1 & " blocks"
	For nI = 0 To UBound (aExtract, 2)
		WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI) & " = """ & Mid (sSource, aExtract (0, nI), aExtract (1, nI)) & """"
		'WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI)
	Next
End If

sSource = "BlockA,Start,1,2,3,End,BlockB,Start,4,5,6,End,BlockC,Start,7,8,9,End"
WScript.Echo "RegExFramedFind search """ & sSource & """"

aExtract = oScrape.RegExFind (sSource, "Block[A-Z]", True, 0)
If Not IsArray (aExtract) Then
	WScript.Echo "RegExFind (1) :: no match"
Else
	WScript.Echo "RegExFind (1) :: " & UBound (aExtract, 2) + 1 & " blocks"
	For nI = 0 To UBound (aExtract, 2)
		WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI) & " = """ & Mid (sSource, aExtract (0, nI), aExtract (1, nI)) & """"
		'WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI)
	Next
End If

sSource = "English Foxes are the same as American Foxes, but are not foxes"

WScript.Echo
WScript.Echo sSource
aExtract = oScrape.RegExFind (sSource, "foxes", True, 0)
If Not IsArray (aExtract) Then
	WScript.Echo "RegExFind (1) :: no match"
Else
	WScript.Echo "RegExFind (1) :: " & UBound (aExtract, 2) + 1 & " blocks"
	For nI = 0 To UBound (aExtract, 2)
		WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI) & " = """ & Mid (sSource, aExtract (0, nI), aExtract (1, nI)) & """"
		'WScript.Echo "Match: " & nI & " = " & aExtract (0, nI) & ", " & aExtract (1, nI)
	Next

	WScript.Echo "All foxes in the string"
	For Each s In oScrape.MatchArrayToStringArray (aExtract, sSource, False, False)
			WScript.Echo "... " & s
	Next
	WScript.Echo "All unique foxes in the string"
	For Each s In oScrape.MatchArrayToStringArray (aExtract, sSource, True, False)
			WScript.Echo "... " & s
	Next
	WScript.Echo "All unique foxes in the string, igoring case"
	For Each s In oScrape.MatchArrayToStringArray (aExtract, sSource, True, True)
			WScript.Echo "... " & s
	Next
End If

Set oScrape = Nothing
' WScript.Quit (0)

' -----------------------------------------------------------
' Example of scraping from a web site.
' -----------------------------------------------------------

' Dim oScrape
Set oScrape = new ScrapeClass

If oScrape.FileExists ("ScrapeClass_Raw_Extract.html") Then
	sSource = oScrape.FileToString ("ScrapeClass_Raw_Extract.html", 0)
Else
	sSource = oScrape.GetHttpToString ("http://www.allplaces.us/dfz.cgi?s=34711&rad=40", "", Empty, "", "")
End If
If sSource <> "" Then
	If Not oScrape.FileExists ("ScrapeClass_Raw_Extract.html") Then
		oScrape.StringToFile "ScrapeClass_Raw_Extract.html", sSource, 0
	End If

	' Store the extract in an XML document
	Set oX = CreateObject("MSXML2.DOMDocument.4.0")
	With oX
		.async = false
		.setProperty "ServerHTTPRequest", true
		.setProperty "NewParser", true
		.preserveWhiteSpace = true
		.appendChild(oX.createProcessingInstruction("xml"," version=" & chr(34) & "1.0" & chr(34) & " encoding=" & chr(34) & "UTF-8" & chr(34)))
		Set oRoot = .createNode (1, "scrape", "")
		.appendChild (oRoot)

		' Get the center point zip code from the form.
		aWorkBlock = oScrape.RegExFramedFind (sSource, "Zip\sCode\sat\sCenter\sof\sSearch:", True, 1, "Radius", True, 1)
		If Not IsArray (aWorkBlock) Then
			WScript.Echo "No match (0)"
		End If
		sWorkBlock = Mid (sSource, aWorkBlock (0, 0), aWorkBlock (1, 0))
		aPos = oScrape.RegExFind (sWorkBlock, "[0-9]{5}", False, 1)
		sCenterZip = Mid (sWorkBlock, aPos (0,0), aPos (1,0))

		' Get the table which contains the rows of data
		aMainBlock = oScrape.RegExFramedFind (sSource, "Zip\sType</td>", True, 1, "Distance is point to point", True, 1)
		If Not IsArray (aMainBlock) Then
			WScript.Echo "No match (1)"
		End If
		sMainBlock = Mid (sSource, aMainBlock (0, 0), aMainBlock (1, 0))

		' Split the main block into the rows of the table.
		aRows = oScrape.RegExFramedFind (sMainBlock, "<tr[>|\s]", True, 0, "<tr[>|\s]", True, 2)
		For nI = 0 To UBound (aRows, 2)
			sRow = Mid (sMainBlock, aRows (0, nI), aRows (1, nI))
			' Split the row into columns.
			aCols = oScrape.RegExFramedFind (sRow, "<td[>|\s]", True, 0, "</td>", True, 1)
			If IsArray (aCols) Then
				Set oRow = .createNode (1, "record", "")
				call oRow.setAttribute("content", "zip-code-entry")
				oRoot.appendChild (oRow)
				Set oCol = .createNode (1, "center_zip_code", "")
				oCol.appendChild(oX.createCDATASection(sCenterZip))
				oRow.appendChild (oCol)
				Set oCol = Nothing

				For nJ = 0 To UBound (aCols, 2)
					sCol = Mid (sRow, aCols (0, nJ), aCols (1, nJ))
					Select Case nJ
						Case 0   ' Zip Code  -- embedded as <td ><a >#####</a></td> -- extract by 5-digit pattern.
							aPos = oScrape.RegExFind (sCol, "[0-9]{5}", False, 1)
							sValue = Mid (sCol, aPos (0,0), aPos (1,0))
							Set oCol = .createNode (1, "zip_code", "")
							oCol.appendChild(oX.createCDATASection(sValue))
							oRow.appendChild (oCol)
							Set oCol = Nothing
						Case 1   ' City, State
							aPos = oScrape.RegExFind (sCol, ">[^<]+<", False, 1)
							sValue = LTrim (RTrim (Mid (sCol, aPos (0,0) + 1, aPos (1,0) - 2)))
							sCity = RTrim (Split (sValue, ",")(0))
							sState = RTrim (Split (sValue, ",")(1))
							Set oCol = .createNode (1, "city", "")
							oCol.appendChild(oX.createCDATASection(sCity))
							oRow.appendChild (oCol)
							Set oCol = Nothing
							Set oCol = .createNode (1, "state", "")
							oCol.appendChild(oX.createCDATASection(sState))
							oRow.appendChild (oCol)
							Set oCol = Nothing
						Case 2   ' Distance
							aPos = oScrape.RegExFind (sCol, ">[^<]+<", False, 1)
							sValue = LTrim (RTrim (Mid (sCol, aPos (0,0) + 1, aPos (1,0) - 2)))
							Set oCol = .createNode (1, "distance", "")
							oCol.appendChild(oX.createCDATASection(sValue))
							oRow.appendChild (oCol)
							Set oCol = Nothing
						Case 3   ' County
							aPos = oScrape.RegExFind (sCol, ">[^<]+<", False, 1)
							sValue = LTrim (RTrim (Mid (sCol, aPos (0,0) + 1, aPos (1,0) - 2)))
							Set oCol = .createNode (1, "county", "")
							oCol.appendChild(oX.createCDATASection(sValue))
							oRow.appendChild (oCol)
							Set oCol = Nothing
						Case 4   ' Time Zone
							aPos = oScrape.RegExFind (sCol, ">[^<]+<", False, 1)
							sValue = LTrim (RTrim (Mid (sCol, aPos (0,0) + 1, aPos (1,0) - 2)))
							Set oCol = .createNode (1, "time_zone", "")
							oCol.appendChild(oX.createCDATASection(sValue))
							oRow.appendChild (oCol)
							Set oCol = Nothing
						Case 5   ' Usage  (PO Box, Standard, etc).
							aPos = oScrape.RegExFind (sCol, ">[^<]+<", False, 1)
							sValue = LTrim (RTrim (Mid (sCol, aPos (0,0) + 1, aPos (1,0) - 2)))
							Set oCol = .createNode (1, "usage", "")
							oCol.appendChild(oX.createCDATASection(sValue))
							oRow.appendChild (oCol)
							Set oCol = Nothing
					End Select
				Next
				Set oRow = Nothing
			End If
		Next
		Set oRoot = Nothing
		oScrape.StringToFile "ScrapeClass_Raw_Extract.xml", .xml, 0
		
	End With
	Set oX = Nothing
Else
	WScript.Echo "Web site content retrieval probably failed"
End If

Set oScrape = Nothing
